import { Libp2p } from '@cerc-io/libp2p';
import { Multiaddr } from '@multiformats/multiaddr';
interface DialWithRetryOptions {
    redialInterval: number;
    maxRetry: number;
}
/**
 * Method to dial remote peer multiaddr with retry on failure
 * Number of retries can be configured using options.maxRetry
 * @param node
 * @param multiaddr
 * @param options
 */
export declare const dialWithRetry: (node: Libp2p, multiaddr: Multiaddr, options: Partial<DialWithRetryOptions>) => Promise<import("@libp2p/interface-connection").Connection>;
/**
 * Get a deterministic pseudonym of form [adjective-color-name] for a given libp2p peer id
 * Eg. 12D3KooWJLXEX2GfHPSZR3z9QKNSN8EY6pXo7FZ9XtFhiKLJATtC -> jolly-green-diann
 * @param peerId
 */
export declare const getPseudonymForPeerId: (peerId: string) => string;
export {};
