//
// Copyright 2023 Vulcanize, Inc.
//
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { uniqueNamesGenerator, adjectives, colors, names } from 'unique-names-generator';
var DEFAULT_DIAL_RETRY_OPTIONS = {
    redialInterval: 5000,
    maxRetry: 5
};
/**
 * Method to dial remote peer multiaddr with retry on failure
 * Number of retries can be configured using options.maxRetry
 * @param node
 * @param multiaddr
 * @param options
 */
export var dialWithRetry = function (node, multiaddr, options) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, redialInterval, maxRetry, i, connection, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = __assign(__assign({}, DEFAULT_DIAL_RETRY_OPTIONS), options), redialInterval = _a.redialInterval, maxRetry = _a.maxRetry;
                i = 0;
                _b.label = 1;
            case 1:
                if (!(i < maxRetry)) return [3 /*break*/, 7];
                _b.label = 2;
            case 2:
                _b.trys.push([2, 4, , 6]);
                console.log("Dialling node ".concat(multiaddr.getPeerId(), " using multiaddr ").concat(multiaddr.toString()));
                return [4 /*yield*/, node.dial(multiaddr)];
            case 3:
                connection = _b.sent();
                return [2 /*return*/, connection];
            case 4:
                err_1 = _b.sent();
                console.log("Could not dial node ".concat(multiaddr.toString()), err_1);
                console.log("Retrying after ".concat(redialInterval, "ms"));
                // TODO: Use wait method from util package.
                // Issue using util package in react app.
                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, redialInterval); })];
            case 5:
                // TODO: Use wait method from util package.
                // Issue using util package in react app.
                _b.sent();
                return [3 /*break*/, 6];
            case 6:
                i++;
                return [3 /*break*/, 1];
            case 7: throw new Error("Stopping dial retry after ".concat(maxRetry, " attempts for multiaddr ").concat(multiaddr.toString()));
        }
    });
}); };
/**
 * Get a deterministic pseudonym of form [adjective-color-name] for a given libp2p peer id
 * Eg. 12D3KooWJLXEX2GfHPSZR3z9QKNSN8EY6pXo7FZ9XtFhiKLJATtC -> jolly-green-diann
 * @param peerId
 */
export var getPseudonymForPeerId = function (peerId) {
    return uniqueNamesGenerator({
        seed: peerId,
        dictionaries: [adjectives, colors, names],
        length: 3,
        style: 'lowerCase',
        separator: '-'
    });
};
//# sourceMappingURL=index.js.map